/// @file			dsObject.cpp
/// @copyright  	Copyright (c) 2014 Toradex AG.
/// $Author:		khv
/// $Date: 			$ 2014-09-18 $
/// @brief:			File contains definitions for dsObject.h file.

/// Header files.
#include <windows.h>
#include <dshow.h>
#include "dsObject.h"

BOOL DsObjectInitialize(dsObjectStruct *dsObjectPtr)
{
	dsObjectPtr->pGraph = NULL;
	dsObjectPtr->pMediaControl = NULL;
	dsObjectPtr->pSeek = NULL;
	dsObjectPtr->pAudio = 0;
	dsObjectPtr->pWindow = NULL;
	dsObjectPtr->startDuration = 0;
	dsObjectPtr->hResult = S_FALSE;
	/// COM initialize.
	CoInitialize(NULL);
	Sleep(50);
	dsObjectPtr->hResult = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&(dsObjectPtr->pGraph));
	if (dsObjectPtr->hResult != S_OK)
	{
		return FALSE;
	}
	dsObjectPtr->hResult = dsObjectPtr->pGraph->QueryInterface(IID_IMediaControl, (VOID**)&(dsObjectPtr->pMediaControl)); 
	if (dsObjectPtr->hResult != S_OK)
	{
		return FALSE;
	}
	dsObjectPtr->hResult = dsObjectPtr->pGraph->QueryInterface(IID_IMediaSeeking, (VOID**)&(dsObjectPtr->pSeek));
	if (dsObjectPtr->hResult != S_OK)
	{
		return FALSE;
	}
	dsObjectPtr->hResult = dsObjectPtr->pGraph->QueryInterface(IID_IBasicAudio, (VOID**)&(dsObjectPtr->pAudio));
	if (dsObjectPtr->hResult != S_OK)
	{
		return FALSE;
	}
	dsObjectPtr->hResult = dsObjectPtr->pGraph->QueryInterface(IID_IVideoWindow, (VOID**)&(dsObjectPtr->pWindow));
	if (dsObjectPtr->hResult != S_OK)
	{
		return FALSE;
	}
	return TRUE;
}

/// Clear the graph and interface it again.
BOOL Reset(dsObjectStruct *dsObjectPtr)
{
	BOOL retVal = FALSE;
	dsObjectPtr->hResult = dsObjectPtr->pMediaControl->Stop();
	if (dsObjectPtr->hResult != S_OK)
	{
		return retVal;
	}
	Sleep(50);
	DsObjectCleanup(dsObjectPtr);
	Sleep(50);
	if (DsObjectInitialize(dsObjectPtr) == TRUE)
	{
		retVal = TRUE;
	}
	return retVal;
}
/// Manual clean up of object.
void DsObjectCleanup(dsObjectStruct *dsObjectPtr)
{
	/// Clean up. 
	dsObjectPtr->pMediaControl->Release(); 
	dsObjectPtr->pSeek->Release(); 
	dsObjectPtr->pAudio->Release();
	dsObjectPtr->pWindow->Release();
	dsObjectPtr->pGraph->Release();
	/// Release COM pointer.
	CoUninitialize();
}