/// @file			dsObject.h
/// @copyright  	Copyright (c) 2014 Toradex AG.
/// $Author:		khv
/// $Date: 			$ 2014-09-18 $
/// @brief:			File declares dsObjectStruct structure for required DirectShow procedures.

#ifndef _DSOBJECT_H_
#define _DSOBJECT_H_
/// Header files.
#include <windows.h>
#include <dshow.h>

/// Macros.
#define MAX_VOL					0
#define MIN_VOL			   -10000
#define NORMAL_PLAYBACK_RATE  1.0
#define MAX_PLAYBACK_RATE	  2.0
#define MIN_PLAYBACK_RATE	  0.4

typedef struct tDsObjectStruct
{
	IGraphBuilder *pGraph;
	IMediaControl *pMediaControl;
	IMediaSeeking *pSeek;
	IBasicAudio *pAudio;
	IVideoWindow *pWindow;
	LONGLONG startDuration;
	HRESULT hResult;
}dsObjectStruct;

/// Create and initialize filter graph.
BOOL DsObjectInitialize(dsObjectStruct *dsObjectPtr);
/// Clear the graph and interface it again.
BOOL Reset(dsObjectStruct *dsObjectPtr);
/// Clean up of object.
void DsObjectCleanup(dsObjectStruct *dsObjectPtr);

typedef enum tState
{
	UNDEFINE,
	LOAD,
	PLAY,
	PAUSE,
	STOP
}state;
#endif