/// @file			handleDeclaration.h
/// @copyright  	Copyright (c) 2014 Toradex AG.
/// $Author:		khv
/// $Date: 			$ 2014-09-18 $
/// @brief:			File declares handleStruct class as container of all required handles.

#ifndef _HANDLE_DECLARATION_H_
#define _HANDLE_DECLARATION_H_
/// Header files.
#include <windows.h>
#include <Commdlg.h>

/// Macros
#define BUFFER			1024
#define ESC_KEY_ASCII	  27
#define SPACE_KEY_ASCII	  32

typedef struct tHandlers
{
	WNDCLASS mainWindow;
	WNDCLASS videoWindow;
	DWORD regMainWindow;
	DWORD regVideoWindow;
	HWND hMainWindow;
	HWND hVideoWindow;
	HWND hCommandBar;
	HMENU hMenuBar;
	HINSTANCE hCurrentInst;
	OPENFILENAME openDialogStruct;
	WCHAR filePathAndName[BUFFER / sizeof(WCHAR)];
	WCHAR fileName[BUFFER / sizeof(WCHAR)];
}handleStruct;

/// Initialization function.
void HandleStructInitialize(handleStruct *handleStructPtr);
/// Clean up function.
void HandleStructCleanup(handleStruct *handleStructPtr);
#endif